/**
	 * Limon - Minko
	 * 05 / 12 / 2012
	 * 
     * @langversion 3.0
     * @playerversion Flash 11.5
     * @author David Massenot (http://artcustomer.fr)
	 * @version 1.0.0.0
**/
package {
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.system.Security;
	
	import artcustomer.limon.minko.api.LimonMinko;
	
	
	/**
	 * Main
	 * 
	 * @author David Massenot
	 */
	public class Main extends Sprite {
		private var _application:LimonMinko;
		
		
		/**
		 * Constructor
		 */
		public function Main():void {
			Security.allowDomain('*');
			Security.allowInsecureDomain('*');
			
			this.addEventListener(Event.ADDED_TO_STAGE, added, false, 0, true);
			this.addEventListener(Event.REMOVED_FROM_STAGE, removed, false, 0, true);
		}
		
		/**
		 * @private
		 */
		private function added(e:Event):void {
			this.removeEventListener(Event.ADDED_TO_STAGE, added);
			
			setupApplication();
		}
		
		/**
		 * @private
		 */
		private function removed(e:Event):void {
			this.removeEventListener(Event.REMOVED_FROM_STAGE, removed);
			
			destroyApplication();
		}
		
		//---------------------------------------------------------------------
		//  Application
		//---------------------------------------------------------------------
		
		/**
		 * @private
		 */
		private function setupApplication():void {
			_application = new LimonMinko();
			_application.contextView = this;		// REQUIRED !
			_application.setup();					// REQUIRED !
		}
		
		/**
		 * @private
		 */
		private function destroyApplication():void {
			if (_application) {
				_application.destroy();
				_application = null;
			}
		}
	}
}