package artcustomer.limon.minko.layers.layer3d {
	import artcustomer.framework.engines.layers.Layer3D;
	import artcustomer.framework.extensions.minko.template.MinkoTemplate;
	
	import artcustomer.limon.minko.layers.layer3d.scenes.*;
	
	
	/**
	 * ApplicationLayer3D
	 * 
	 * @author David Massenot
	 */
	public class ApplicationLayer3D extends Layer3D {
		
		
		/**
		 * Constructor
		 */
		public function ApplicationLayer3D() {
			super();
		}
		
		//---------------------------------------------------------------------
		//  Template
		//---------------------------------------------------------------------
		
		/**
		 * @private
		 */
		private function addTemplate():void {
			this.attachTemplate(MinkoTemplate);
		}
		
		//---------------------------------------------------------------------
		//  Scenes
		//---------------------------------------------------------------------
		
		/**
		 * @private
		 */
		private function addScenes():void {
			this.addScene(SceneAstroBoy);
		}
		
		
		/**
		 * Setup Layer3D.
		 */
		override public function setup():void {
			super.setup();
			
			addTemplate();
		}
		
		/**
		 * Destroy Layer3D.
		 */
		override public function destroy():void {
			super.destroy();
		}
		
		/**
		 * Called when Context3D is created.
		 */
		override protected function create():void {
			addScenes();
		}
	}
}